# Thanks to http://www.sanitarium.net/golug/rsync_backups_2010.html for the
# idea.
-# Copyright (C) 2011-2014 Simon Ruderich
+# Copyright (C) 2011-2016 Simon Ruderich
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
cd "$1"
shift
-# Get absolute path to last backup directory.
+# Get path to last backup directory.
dest=./
for x in backup-*; do
test -d "$x" || continue
dest="../$x" # relative to destination directory
done
-target=backup-`date '+%Y-%m-%d-%H-%M-%S'`
+target="backup-$(date '+%Y-%m-%d-%H-%M-%S')"
+target_tmp="partial-$target"
-if test -d current; then
- echo "Target directory 'current' already exists, aborting." >&2
- exit 1
-fi
-
-mkdir current
+mkdir "$target_tmp"
rsync \
--verbose --itemize-changes --human-readable \
--archive --hard-links --sparse --numeric-ids --one-file-system \
--link-dest="$dest" \
- "$@" current \
+ "$@" "$target_tmp" \
|| {
- # Try to remove "current" without changing the exit code. In case the
- # connection failed without transferring any files, we want the next
- # backup to be able to run.
+ # Try to remove the target directory without changing the exit code. In
+ # case the connection failed without transferring any files, we want to
+ # remove the empty directory.
code=$?
- rmdir current 2>/dev/null || true
+ rmdir "$target_tmp" 2>/dev/null || true
exit $code
}
-mv current "$target"
+mv "$target_tmp" "$target"